unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UnitV, StdCtrls, DB, IBCustomDataSet, IBQuery, IBDatabase ;

type
  TForm1 = class(TForm)
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    IBQuery1: TIBQuery;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button1: TButton;
    Label6: TLabel;
    Edit4: TEdit;
    Button2: TButton;
    Memo1: TMemo;
    Button3: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
    DatFile : string ;  // f[^t@C
    n : array[1..6] of integer ;   // 
    procedure OpenDatFile(fn:string) ;
    procedure SaveDatFile(fn:string) ;
  public
    { Public 錾 }
    procedure DataBaseConnect ;
    procedure DataBaseDisConnect ;
    function  DataTableCheck(t:string) : Boolean ;
    function  DataTableMaking1 : Boolean ;
    function  DataTableDelete1 : Boolean ;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// f[^t@Cǂݍ
procedure TForm1.OpenDatFile(fn:string) ;
var
   F : TextFile ;
   s : string ;
begin
   DBserv := '192.168.1.10:';
   DBfold := 'C:\data\';
   DBname := 'ADDRESS.FDB';

   // ǂݍ
   if not(FileExists(fn)) then exit;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);

      ReadLn(F, DBserv);
      ReadLn(F, DBfold);
      ReadLn(F, DBname);
      ReadLn(F, s);  Form1.Left  := SInt(s) ;
      ReadLn(F, s);  Form1.Top   := SInt(s) ;

      CloseFile(F);
   except
      CloseFile(F);
   end;
end;

// f[^t@Cۑ
procedure TForm1.SaveDatFile(fn:string) ;
var
   F : TextFile ;
   s : string ;
begin
   try
      AssignFile(F, fn);
      ReWrite(F);

      WriteLn(F, DBserv);
      WriteLn(F, DBfold);
      WriteLn(F, DBname);
      s := IntToStr(Form1.Left);    WriteLn(F, s);
      s := IntToStr(Form1.Top);     WriteLn(F, s);

      CloseFile(F);
   except
      CloseFile(F);
      if FileExists(fn) then DeleteFile(fn);
   end;
end;

// f[^x[Xɐڑ
procedure TForm1.DataBaseConnect ;
begin
   // f[^x[Xڑ
   IBDataBase1.DatabaseName := DBserv + DBfold + DBname ;
   IBDataBase1.Connected := False ;
   IBDatabase1.Params.Clear ;
   IBDatabase1.Params.Add('USER_NAME=SYSDBA');
   IBDatabase1.Params.Add('PASSWORD=masterkey');
   try
      IBDatabase1.Connected := True ;
   except
      // G[f[^x[Xؒf
      DataBaseDisConnect ;
   end;
end;

// f[^x[Xؒf
procedure TForm1.DataBaseDisConnect ;
begin
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
   IBDatabase1.Connected := False ;
end;

// f[^e[ũ`FbN
function TForm1.DataTableCheck(t:string) : Boolean ;
begin
   ComboBox1.Items.Clear ;
   IBDatabase1.GetTableNames(ComboBox1.Items);
   if ComboBox1.Items.IndexOf(t) >= 0 then
      Result := True
   else
      Result := False ;
end;

// f[^e[u TABLE1 쐬
function TForm1.DataTableMaking1 : Boolean ;
begin
   Result := False ;
   try
      IBTransaction1.Active := False ;
      IBTransaction1.StartTransaction ;
      IBQuery1.Close;
      IBQuery1.ParamCheck := False ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('CREATE TABLE ' + TABLE1 + ' (' );
         Add('  ZIP  VARCHAR(7),');
         Add('  ADK1 VARCHAR(' + IntToStr(n[1]) + '),');
         Add('  ADK2 VARCHAR(' + IntToStr(n[2]) + '),');
         Add('  ADK3 VARCHAR(' + IntToStr(n[3]) + '),');
         Add('  ADR1 VARCHAR(' + IntToStr(n[4]) + '),');
         Add('  ADR2 VARCHAR(' + IntToStr(n[5]) + '),');
         Add('  ADR3 VARCHAR(' + IntToStr(n[6]) + ')');
         Add('  );');
      end;
      if not(IBQuery1.Prepared) then IBQuery1.Prepare;
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
      Result := True ;
   except
      IBTransaction1.Rollback ;
   end;
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// f[^e[u TABLE1 폜
function TForm1.DataTableDelete1 : Boolean ;
begin
   Result := False ;
   try
      IBTransaction1.Active := False ;
      IBTransaction1.StartTransaction ;
      IBQuery1.Close;
      IBQuery1.ParamCheck := False ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('DROP TABLE ' + TABLE1 + ';' );
      end;
      if not(IBQuery1.Prepared) then IBQuery1.Prepare;
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
      Result := True ;
   except
      IBTransaction1.Rollback ;
   end;
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// N
procedure TForm1.FormShow(Sender: TObject);
begin
   n[1] := 0 ;
   n[2] := 0 ;
   n[3] := 0 ;
   n[4] := 0 ;
   n[5] := 0 ;
   n[6] := 0 ;
   Label4.Caption := '' ;
   Label5.Caption := '' ;
   // vÔtH_擾܂
   AppPath := ExtractFilePath(Application.ExeName) ;
   // f[^t@ĆAvOt@C̊gqu.datvɂ
   DatFile := ChangeFileExt(Application.ExeName,'.dat') ;
   OpenDatFile(DatFile) ;
   if (DBfold = '')or(DBname = '') then exit;
   // NɃf[^x[X쐬܂
   IBDataBase1.DatabaseName := DBserv + DBfold + DBname ;
   IBDatabase1.Params.Clear ;
   IBDatabase1.Params.Add('USER "SYSDBA"');
   IBDatabase1.Params.Add('PASSWORD "masterkey"');
   IBDatabase1.Params.Add('PAGE_SIZE 4096');
   try
      IBDataBase1.CreateDatabase;
   except
      // ɍ쐬ς
   end;
   // f[^x[Xڑ
   DataBaseConnect ;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   // f[^x[Xؒf
   DataBaseDisConnect ;
   //
   SaveDatFile(DatFile) ;
end;

// [X֔ԍ쐬]
procedure TForm1.Button1Click(Sender: TObject);
var
   fn : string ;
   F : TextFile ;
   s : string ;
   u : TStringList;
   i,j,k,cnt : integer ;
   t : array[0..6] of string ;
begin
   if not(IBDatabase1.Connected) then exit ; // ڑ
   fn := AppPath + 'KEN_ALL.CSV' ;
   if not(FileExists(fn)) then begin
      ShowMessage('X֔ԍf[^uKEN_ALL.CSVv܂');
      exit ;
   end;
   Button1.Enabled := False ;
   // `FbN
   Label4.Caption := '`FbNł';
   Label4.Update ;
   Label5.Caption := '';
   Label5.Update ;
   for i:=1 to 6 do n[i] := 0 ;
   u := TStringList.Create ;
   cnt := 0 ;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);
      while not(Eof(F)) do begin
         ReadLn(F, s);
         // ESC:f
         if ((GetAsyncKeyState(VK_ESCAPE) and $8000) > 0) then begin
            CloseFile(F);
            u.Free ;
            Label4.Caption := '[ESC]L[܂';
            Label4.Update ;
            Label5.Caption := 'f';
            Label5.Update ;
            Button1.Enabled := True ;
            exit ;   // Ȃꍇ͒f
         end;
         // ڐ؂o
         u.CommaText := s ;
         j := u.Count ;
         if (j < 9) then continue ;
         t[0] := Trim(u[2]);
         for i:=1 to 6 do
            t[i] := QTrim(u[i+2]) ;
         if (AnsiPos('ȉ',t[6]) > 0)
          or(AnsiPos('̎',t[6]) > 0) then begin
            t[3] := '' ;
            t[6] := '' ;
         end;
         // JE^
         Inc(cnt);
         if ((cnt mod 500) = 0) then begin
            Label5.Caption := 'ǎ撆F'+IntToStr(cnt)+'s';
            Label5.Update ;
         end;
         // őT
         for i:=1 to 6 do begin
            j := Length(t[i]);
            if (n[i] < j) then n[i] := j ;
         end;
      end;
      CloseFile(F);
   except
      CloseFile(F);
   end;
   u.Free ;
   // ݂̃e[u폜
   Label4.Caption := '݃e[u폜';
   Label4.Update ;
   Label5.Caption := '';
   Label5.Update ;
   if (DataTableCheck(TABLE1)) then begin
      // e[uꍇ͍폜
      if not(DataTableDelete1) then begin
         Label4.Caption := '';
         Label4.Update ;
         ShowMessage('X֔ԍe[u폜o܂B' + #13 + #10
                   + '\tgŗpĂȂmFĉB');
         Button1.Enabled := True ;
         exit ;   // Ȃꍇ͒f
      end;
   end;
   // VKe[u쐬
   Label4.Caption := 'VKe[u쐬';
   Label4.Update ;
   if not(DataTableMaking1) then begin
      Label4.Caption := '';
      Label4.Update ;
      ShowMessage('X֔ԍe[uVK쐬o܂B');
      Button1.Enabled := True ;
      exit ;   // 쐬oȂꍇ͒f
   end;
   // f[^o^
   Label4.Caption := 'f[^o^';
   Label4.Update ;
   Label5.Caption := '';
   Label5.Update ;
   u := TStringList.Create ;
   k := 0 ;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);
      while not(Eof(F)) do begin
         ReadLn(F, s);
         // ڐ؂o
         u.CommaText := s ;
         j := u.Count ;
         if (j < 9) then continue ;
         t[0] := Trim(u[2]);
         for i:=1 to 6 do
            t[i] := QTrim(u[i+2]) ;
         if (AnsiPos('ȉ',t[6]) > 0)
          or(AnsiPos('̎',t[6]) > 0) then begin
            t[3] := '' ;
            t[6] := '' ;
         end;
         // JE^
         Inc(k);
         if ((k mod 500) = 0) then begin
            Label5.Caption := 'o^F'+IntToStr(k)+'^'+IntToStr(cnt);
            Label5.Update ;
         end;
         // f[^ǉ
         for i:=0 to 6 do begin
            if (t[i] = '') then
               t[i] := 'NULL'
            else
               t[i] := '''' + t[i] + '''' ;
         end;
         try
            IBTransaction1.Active := False ;
            IBTransaction1.StartTransaction ;
            IBQuery1.Close;
            IBQuery1.ParamCheck := False ;
            with IBQuery1.SQL do begin
               Clear ;
               Add('INSERT INTO ' + TABLE1 + ' (');
               Add('  ZIP, ADK1, ADK2, ADK3,');
               Add('  ADR1, ADR2, ADR3)');
               Add('VALUES (');
               for i:=0 to 6 do begin
                  if (i < 6) then
                     s := '  ' + t[i] + ','
                  else
                     s := '  ' + t[i] + ');' ;
                  Add(s);
               end;
            end;
            if not (IBQuery1.Prepared) then IBQuery1.Prepare;
            IBQuery1.ExecSQL;
            IBTransaction1.Commit;
         except
            IBTransaction1.Rollback ;
         end;
         IBQuery1.Active := False ;
         IBTransaction1.Active := False ;
      end;
      CloseFile(F);
   except
      CloseFile(F);
   end;
   u.Free ;
   // f[^o^
   Label4.Caption := 'f[^o^';
   Label4.Update ;
   Label5.Caption := 'F'+IntToStr(k)+'^'+IntToStr(cnt);
   Label5.Update ;

   Button1.Enabled := True ;
end;

// eXg
procedure TForm1.Button2Click(Sender: TObject);
var
   z,s : string ;
   i : integer ;
begin
   if not(IBDatabase1.Connected) then exit ; // ڑ
   z := Edit4.Text ;
   if (Trim(z) = '') then exit ;
   if not(DataTableCheck(TABLE1)) then exit ;   // X֔ԍ
   //
   Button2.Enabled := False ;

   Memo1.Lines.Clear ;
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      Add('SELECT * FROM '+TABLE1+' WHERE ZIP LIKE '''+z+'%'';') ;
   end;
   try
      IBQuery1.Open ;
      IBQuery1.First ;
      while not(IBQuery1.Eof) do begin
         if ((GetAsyncKeyState(VK_ESCAPE) and $8000) > 0) then break ;  // ESC:f
         s := '' ;
         for i:=0 to 6 do
            s := s + IBQuery1.Fields[i].AsString + ',' ;
         Memo1.Lines.Add(s);
         IBQuery1.Next ;
      end;
   except
      ;
   end;
   IBQuery1.Active := False ;

   Button2.Enabled := True ;
end;

// 
procedure TForm1.Button3Click(Sender: TObject);
begin
   close ;
end;

end.
